Codeforces Round #369 (Div. 2)---C - Coloring Trees (很妙的DP题)

时间:2023-11-26 00:02:38

题目链接

http://codeforces.com/contest/711/problem/C

Description

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples
input
3 2 2
0 0 0
1 2
3 4
5 6
output
10
input
3 2 2
2 1 2
1 3
2 4
3 5
output
-1
input
3 2 2
2 0 0
1 3
2 4
3 5
output
5
input
3 2 3
2 1 2
1 3
2 4
3 5
output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题意:有n棵树,m种颜料,要求现在要给这些树涂上颜料,最后涂成k段(连续颜色相同划为一段如2, 1, 1, 1, 3, 2, 2, 3, 1, 3是7段),有些树已经涂了,则不涂了只能涂一次,输入n个数(每个数为0~m),0表示还没有涂,1~m表示已经涂了哪种颜料。接下来输入n行m列,表示每棵树涂成每种颜色所要的颜料量。现在要把所有树都涂上颜料涂成k段,求最少要用的颜料量;

思路:DP题,看到数据范围100,只能用3重循环解决问题(据说这题4重循环也能过~) dp[i][j][k] 表示从第一棵树开始涂,涂到第i棵树,有j段,且第i棵树涂的k种颜料所需要的最少颜料量,那么有状态转移方程dp[i][j][k]=min(my,dp[i-1][j][k])+cost[i][k]; my其实就是my=min( dp[i-1][j-1][非k] );  最后min( dp[n][k][i]  1<=i<=m ) 就是答案;

代码如下:

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <cmath>
#define eps 1e-8
#define maxn 105
#define inf 0x3f3f3f3f3f3f3f3f
#define IN freopen("in.txt","r",stdin);
using namespace std;
int c[];
long long cost[][];
long long dp[][][];
pair<long long,int> mfirst[][],msecond[][]; int main()
{
int n,m,s;
while(scanf("%d%d%d",&n,&m,&s)!=EOF)
{
for(int i=;i<=n;i++)
scanf("%d",&c[i]);
for(int i=;i<=n;i++)
{
for(int j=;j<=m;j++)
scanf("%I64d",&cost[i][j]);
if(c[i]) cost[i][c[i]]=;
} memset(dp,inf,sizeof(dp));
memset(mfirst,inf,sizeof(mfirst));
memset(msecond,inf,sizeof(msecond));
for(int i=;i<=m;i++)
dp[][][i]=;
mfirst[][]=make_pair(,-);
msecond[][]=make_pair(,-);
for(int i=;i<=n;i++)
{
for(int j=;j<=s&&j<=i;j++)
{
for(int k=;k<=m;k++)
{
if(c[i]&&c[i]!=k) continue;
long long my=mfirst[i-][j-].first;
if(mfirst[i-][j-].second==k) my=msecond[i-][j-].first; dp[i][j][k]=min(my,dp[i-][j][k])+cost[i][k];
if(dp[i][j][k]<mfirst[i][j].first){
msecond[i][j].first=mfirst[i][j].first;
mfirst[i][j].first=dp[i][j][k];
msecond[i][j].second=mfirst[i][j].second;
mfirst[i][j].second=k;
}
else if(dp[i][j][k]<msecond[i][j].first){
msecond[i][j].first=dp[i][j][k];
msecond[i][j].second=k;
}
}
}
}
long long ans=inf;
for(int i=;i<=m;i++)
ans=min(ans,dp[n][s][i]);
if(ans==inf)
puts("-1");
else
printf("%I64d\n",ans);
}
return ;
}